package l06_interfaces;

public class MammalTest {

	interface IAnimal {
		int numberOfLegs = 4; // final by default
		void eat();
		void travel();
	}

	static class Mammal implements IAnimal {

//	If any of the interface methods (eat() or travel()) is not implemented, the
//	class would have to be abstract

		@Override
		public void eat() {
			System.out.println("Mammal eats");
		}

		@Override
		public void travel() {
			System.out.println("Mammal travels");
		}
	}

	public static void main(String[] args) {

		System.out.println("numberOfLegs = " + IAnimal.numberOfLegs);
//		numberOfLegs = 5;	//	error: cannot assign a value to final variable
		IAnimal mammal = new Mammal();
		mammal.eat();
		mammal.travel();
	}
}

